<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on December 2, 2009 at 7:47:20 pm</time-stamp>
<!-- Changes from: PV-CME-Core(Green.13,apikovsky)  to: PV-CME-Core (Green.14,carry)+ -->


<methods>
<class-id>PROVISO.PvCmeEngine</class-id> <category>processing (hourly)</category>

<body package="PV-CME-Core" selector="processCloseHourFile:">processCloseHourFile: aFilename 
	"Naming of CLOSE_HOUR is x.CLOSE_HOUR.y, or CLOSE_HOUR.y , where y is the collector number"

	| closeHourFileCollNumber lastToken |
	self stats incrementCloseHourFilesProcessedBy: 1.
	lastToken := (aFilename tail tokensBasedOn: $.) readStream upTo: 'CLOSE_HOUR'; next.
	closeHourFileCollNumber := lastToken isNil
		ifTrue: [0]
		ifFalse: [lastToken asNumber].
	((self collectorNumbers includes: closeHourFileCollNumber) 
		or: [closeHourFileCollNumber = 0]) 
			ifFalse: [^nil].
	self logCloseHourForCollector: closeHourFileCollNumber.
	self rawBucketsKeysAndValuesDo: 
			[:keysArray :eachRawBucket | 
			| resourceId resource |
			resourceId := keysArray at: 2.
			resource := self pvModel resourceWithId: resourceId.
			(resource notNil and: [resource collectorNumber = closeHourFileCollNumber]) 
				ifTrue: 
					[eachRawBucket setCompletedFlag]]</body>
</methods>


</st-source>
